/*============================================================================
//	apci54s.c
//
//	aPCI-P54
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci54w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP54[]   = _T("aPCI-P54");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	APCI54RESOURCE Ri;			/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				/* ۰ذ̒l */
	DWORD dwDirections;			/* ިڸ */
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// apci54.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci54wDllOpen() == FALSE){
		ErrorMessage(APCI54_SLOT_AUTO);
		return 1;				/* apci54.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P54 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci54wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI54_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("GetVersion\n")
							_T("DLL    Version\t: %08lxh\n")
							_T("Driver Version\t: %08lxh"),
							dwDLLVer,
							dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P54̎gp錾
	//-----------------------------------------------*/
	wLogSlot = APCI54_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Apci54wCreate(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(APCI54_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("aPCI-P54 Created\n\n")
							_T("LogSlot: %2d"),
							wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-----------------------------------------------*/
	if (Apci54wGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci54wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Board Name: %s\n")
							_T("IO Address: %04xh-%04xh\n")
							_T("Switch    : %x\n"),
							szP54,
							Ri.dwIOPortBase[0],
							Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1,
							dwSwVal);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port A ިڸ݂o͂ɐݒ肷
	//-----------------------------------------------*/
	if (Apci54wGetDirections(wLogSlot, &dwDirections) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	dwDirections = ~APCI54_DIR_A_INPUT & dwDirections;	/* A Port ޯĂo͂ɕύX */
	if (Apci54wSetDirections(wLogSlot, dwDirections) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("Port A ̃fBNVo͂ɕύX"));
	/*-------------------------------------------------
	// Port A ɔCӂްo
	//-----------------------------------------------*/
	cbDat = (BYTE)0x55;
	if (Apci54wOutPort(wLogSlot, APCI54_PORT_A, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port A փf[^o\n")
							_T("Port A Out Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port B ިڸ݂͂ɐݒ
	//-----------------------------------------------*/
	if (Apci54wGetDirections(wLogSlot, &dwDirections) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	dwDirections = APCI54_DIR_B_INPUT | dwDirections;	/* B Port ޯĂ͂ɕύX */
	if (Apci54wSetDirections(wLogSlot, dwDirections) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("Port B ̃fBNV͂ɕύX"));
	/*-------------------------------------------------
	// Port B ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Apci54wInPort(wLogSlot, APCI54_PORT_B, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port B f[^\n")
							_T("Port B In Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P54̎gpJ
	//-----------------------------------------------*/
	if (Apci54wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-P54 Closed"));
	/*-------------------------------------------------
	// apci54.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci54wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//===========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//===========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci54wGetLastError(wLogSlot);
	TCHAR szBuf[256];

	switch (dwRes){
		case APCI54_ERR_SYSTEM:
			_stprintf_s(szBuf, 256, _T("System error\n\n")
									_T("Error code: %08lxh"),
									GetLastError());
			break;
		case APCI54_ERR_WRAPDLL:
			_stprintf_s(szBuf, 256, _T("DLL Load error"));
			break;
		default:
			_stprintf_s(szBuf, 256, _T("aPCI-P54 error\n\n")
									_T("Error code: %08lxh"),
									dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
