/*============================================================================
//	apci54w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/09/10
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci54w.h"	/* aPCI-P54 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci54wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci54GetVersion = NULL;
static FARPROC pApci54Create = NULL;
static FARPROC pApci54Close = NULL;
static FARPROC pApci54GetResource = NULL;
static FARPROC pApci54InPort = NULL;
static FARPROC pApci54OutPort = NULL;
static FARPROC pApci54GetLastError = NULL;
static FARPROC pApci54GetSwitchValue = NULL;
static FARPROC pApci54GetDirections = NULL;
static FARPROC pApci54SetDirections = NULL;

/*============================================================================
// 	  apci54.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI54_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci54wGetDllExportFunc();
			if (TRUE != Result)
				Apci54wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci54.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aPCI-P54 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aPCI-P54̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54Create)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aPCI-P54̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54Close)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wGetResource(WORD wLogSlot, PAPCI54R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54GetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54InPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54OutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
/*============================================================================
// 	  aPCI-P54̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci54wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI54_ERR_WRAPDLL;
	else
		return (*pApci54GetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
//		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*============================================================================
// 	  ިڸ݂̏Ԃ擾
// 	  wLogSlot		ިڸ݂̏Ԃ擾޲̘_ۯĔԍ
//		  pdwDirections ިڸݏԂi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wGetDirections(WORD wLogSlot, PDWORD pdwDirections)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54GetDirections)(wLogSlot, pdwDirections);
	return Result;
}
/*============================================================================
// 	  ިڸ݂Ă
// 	  wLogSlot		ިڸ݂Ă޲̘_ۯĔԍ
//		  dwDirections	Ăިڸ݂̓e
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci54wSetDirections(WORD wLogSlot, DWORD dwDirections)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci54SetDirections)(wLogSlot, dwDirections);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci54wGetDllExportFunc()
{
	/* Apci54GetVersion ̱ڽ擾 */
	pApci54GetVersion = GetProcAddress(hDLL, _T("Apci54GetVersion"));
	if (pApci54GetVersion == NULL)
		return FALSE;

	/* Apci54Create ̱ڽ擾 */
	pApci54Create = GetProcAddress(hDLL, _T("Apci54Create"));
	if (pApci54Create == NULL)
		return FALSE;

	/* Apci54Close ̱ڽ擾 */
	pApci54Close = GetProcAddress(hDLL, _T("Apci54Close"));
	if (pApci54Close == NULL)
		return FALSE;

	/* Apci54GetResource ̱ڽ擾 */
	pApci54GetResource = GetProcAddress(hDLL, _T("Apci54GetResource"));
	if (pApci54GetResource == NULL)
		return FALSE;

	/* Apci54InPort ̱ڽ擾 */
	pApci54InPort = GetProcAddress(hDLL, _T("Apci54InPort"));
	if (pApci54InPort == NULL)
		return FALSE;

	/* Apci54OutPort ̱ڽ擾 */
	pApci54OutPort = GetProcAddress(hDLL, _T("Apci54OutPort"));
	if (pApci54OutPort == NULL)
		return FALSE;

	/* Apci54GetLastError ̱ڽ擾 */
	pApci54GetLastError = GetProcAddress(hDLL, _T("Apci54GetLastError"));
	if (pApci54GetLastError == NULL)
		return FALSE;

	/* Apci54GetSwitchValue ̱ڽ擾 */
	pApci54GetSwitchValue = GetProcAddress(hDLL, _T("Apci54GetSwitchValue"));
	if (pApci54GetSwitchValue == NULL)
		return FALSE;

	/* Apci54GetDirections ̱ڽ擾 */
	pApci54GetDirections = GetProcAddress(hDLL, _T("Apci54GetDirections"));
	if (pApci54GetDirections == NULL)
		return FALSE;

	/* Apci54SetDirections ̱ڽ擾 */
	pApci54SetDirections = GetProcAddress(hDLL, _T("Apci54SetDirections"));
	if (pApci54SetDirections == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
